global pie "pie(1, color("0 35 69")) pie(2, color("0 173 228")) pie(3, color("0 96 104")) pie(4, color("109 110 112")) pie(5, color("0 100 80"))  pie(6, color("27 117 184")) pie(7, color("0 35 69"*0.5)) pie(8, color("0 173 228"*0.5)) pie(9, color("0 96 104"*0.5)) pie(10, color("27 117 184"*0.5)) pie(121, color("109 110 112"*0.5)) pie(12, color("0 100 80"*0.5)) " 
global bar "bar(1, color("0 35 69")) bar(2, color("0 173 228")) bar(3, color("0 96 104")) bar(4, color("109 110 112")) bar(5, color("0 100 80")) bar(6, color("27 117 184"))  bar(7, color("0 35 69"*0.5)) bar(8, color("0 173 228"*0.5)) bar(9, color("0 96 104"*0.5)) bar(10, color("27 117 184"*0.5)) bar(11, color("109 110 112"*0.5)) bar(12, color("0 100 80"*0.5))" 

	if $byyear > 1 {
		global period "$startyr-$endyr"
				}
	if $byyear == 1  {
		global period "$endyr"
				}
	if $manuf == 0  {
		global sector "all"
			}			
	if $manuf == 1 {
		global sector "manufacturing only"
			}	
	if $manuf == 0 & $agric == 0 {
		global sector "except agriculture"
			}	
capture program drop vartitle
program def vartitle
	replace variabletit = "Total Firms" if variable == "N"
	replace variabletit = "Total Workers" if variable == "L"
	replace variabletit = "Total ${Ytit} ${units}" if variable == "$Y"
	replace variabletit = "Total $rLCtit ${units}" if variable == "$rLC"
	replace variabletit = "Total $rKtit ${units}" if variable == "$K"
end
capture program drop profile
program def profile
	if "`1'" == "$Yvar" {
		global fyear = $Yvar_mnyr
		global lyear = $Yvar_mxyr
			}
		if "`1'" ~= "$Yvar" {
		global fyear = $startyr
		global lyear = $endyr
			}
	graph pie `1' if `1' >=0 & year == $lyear [$wgt=wgt], over(`2') ///
	$pie plabel(_all per, size(vsmall) color(white) format(%9.2f)) ///
	plotregion(lstyle(none)) subtitle("${country}: Share `3' ($lyear)", color(black) size(medium)) /// 
	legend(size(vsmall) color(black))  note("$datasource" "{it:WB-Job Diagnostics}", size(vsmall) color(black))
	qui graph save "Fig`6'a_`1'_`2'_$CCC.gph", replace
	qui graph export "gr_png\Fig`6'a_`1'_`2'_$CCC.png", as(png) replace

	graph hbar (sum) `1' if `1' >=0 & (year == $fyear | year == $lyear) [$wgt=wgt], /// 
	over(year, sort((sum)1) label(angle(horizontal) labsize(vsmall))) /// 
	over(`2', label(angle(horizontal) labsize(vsmall))) legend(off)  /// 
	note("$datasource" "{it:WB-Job Diagnostics}", size(vsmall) color(black)) /// 	
	title("${country}: Total `3' `4'", color(black) size(medsmall)) ytitle(`5' , size(vsmall)) ylab(, labsize(vsmall)) 
	qui graph save "Fig`6'b_`1'_`2'_$CCC.gph", replace
	qui graph export "gr_png\Fig`6'b_`1'_`2'_$CCC.png", as(png) replace
	if $byyear == 1 {
	gr combine "Fig`6'a_`1'_`2'_$CCC.gph" "Fig`6'b_`1'_`2'_$CCC.gph", cols(2) 
	graph save "Fig`6'b&c_`1'_`2'_$CCC.gph", replace
	graph export "gr_png\Fig`6'b&c_`1'_`2'_$CCC.png", as(png) replace
				}
	if $byyear > 1 {
		sum year if `1' ~= .
		local mnyr = r(min)
		local mxyr = r(max)
		graph bar (sum)  `1' if `1' >=0  & year >= `mnyr'  [$wgt=wgt], over(`2', label(angle(horizontal) labsize(vsmall))) /// 
		over(year, sort((sum)1) label(angle(vertical) labsize(vsmall))) ///
		$bar subtitle("${country}: Share `3' `4'", color(black) size(medsmall)) ///
		percent asyvars stack  ytitle(`5', size(vsmall)) ylab(, labsize(vsmall)) /// 
		legend(size(vsmall) color(black) rows(`7')) ytitle(%, size(small))  /// 
		note("$datasource" "{it:WB-Job Diagnostics}", size(vsmall) color(black))		
		qui graph save "Fig`6'c_`1'_`2'_$CCC.gph", replace
		graph export "gr_png\Fig`6'c_`1'_`2'_$CCC.png", as(png) replace
		gr combine "Fig`6'b_`1'_`2'_$CCC.gph" "Fig`6'c_`1'_`2'_$CCC.gph", cols(2) 
		graph save "Fig`6'b&c_`1'_`2'_$CCC.gph", replace
		graph export "gr_png\Fig`6'b&c_`1'_`2'_$CCC.png", as(png) replace
				}
		preserve
			decode `2', g(categorys)
			collapse (sum)  var_total = `1' (mean) var_mean = `1' (min) var_min = `1'  (max) var_max = `1'  if year == $lyear & `2' ~= . [$wgt=wgt], by(`2' categorys)
			cap la drop _all
			g year = $lyear
			g var = "`3'"
			g dimension = "`2'"
			ren `2' categoryn
			replace dimension = "$prodvartit" if "`2'" == "${prodvar}_quartile"
 			local var "year var dimension categoryn categorys var_total var_mean var_min var_max"
			foreach v in `var' {
				la var `v' ""
					}
			keep `var'
			order `var'
			append using "T1_sumstats_${endyr}_$CCC.dta"
			save "T1_sumstats_${endyr}_$CCC.dta", replace
	restore
end 	
cap program drop mktsh
program define mktsh
preserve
		keep if year == $endyr
		gsort sector3 PROD$D -$Y
		bys sector3 PROD$D: g n_$Y = _n if $Y ~= .
		g S_top4 = $Y if n_$Y <= 4  
		gsort sector3 PROD$D -L
		bys sector3 PROD$D: g n_L = _n if L~=.
		g L_top4 = L if n_L <= 4  
		collapse (sum) N $Y L S_top4 L_top4 if  PROD$D ~=. & sector3 ~= ., by(PROD$D sector3)
			egen St =sum($Y)
			egen Lt =sum(L)
			egen Nt=total(N) 
			egen S_tot =sum($Y), by(sector3)
			egen L_tot =sum(L), by(sector3)
			egen N_tot =sum(N), by(sector3)
			forval i = 1(1)3 {
				g shS`i' = S_tot/St if sector3 == `i'
				g shL`i' = L_tot/Lt if sector3 == `i'
				g shN`i'=N_tot/Nt if sector3 == `i'
				sum shS`i' 
				local shS`i' = r(mean)
				sum shL`i' 
				local shL`i' = r(mean)
				sum shN`i' 
				local shN`i' = r(mean)
						}
			g sh_nic_S = $Y/S_tot
			g sh_nic_L = L/L_tot
			g sh_nic_N = N/N_tot
			g shL_top4_nic =  L_top4/L
			g shS_top4_nic =  S_top4/$Y
			drop if sector3 == . 
			gsort  sector3 -sh_nic_L -sh_nic_S
			bys sector3: g n = _n if L ~= .
			drop if n > 10
			keep sector3 PROD$D N sh_nic_L sh_nic_S shL_top4_nic shS_top4_nic sh_nic_N 
			la var sh_nic_S "Market share (Agriculture, Manufacture or Services)"
			la var sh_nic_L "Labor share (Agriculture, Manufacture or Services)"
			la var sh_nic_N  "Share Nr. of firms (Agriculture, Manufacture or Services)"
			la var shS_top4_nic "Top 4 firm's market share (revenue) $endyr (in isicv4 -4d)"
			la var shL_top4_nic "Top 4 firm's sector labor share $endyr  (in isicv4 -4d)"
			format sh* %9.3f
			g country = "$country"
			order country sector3 PROD$D N sh_nic_N sh_nic_L shL_top4_nic sh_nic_S  shS_top4_nic 
			forval i = 1(1)3 {
				sum sector3
				local N = r(N) + 1
				set obs `N'
				replace sector3 = `i' if sector3 == . 
				replace sh_nic_S = `shS`i'' if sh_nic_S == .
				replace sh_nic_L = `shL`i'' if sh_nic_L == .
						}
			la def sector3 1 "Agriculture" 2 "Manufacturing" 3 "Services", modify
			la val sector3 sector3
			decode sector3, g(sector3s)
			la var PROD$D "ISIC4 ${D}-digits"
			la var country "country"
			la var sector3 "Sector"
			la var N "Nr. of Firms"		
			cap la drop _all	
			order country sector3 sector3s			
			export excel using "Tables_JDD_$CCC",  sheet("Table2")  firstrow(varlabels) sheetmodify	
	restore			
end

cap program drop table3
program def table3
	cap egen nyr = group(year)
	sum nyr
	global mx = r(max)
	local order "variable dimension categories s_categories"
	local vars "N L"
	foreach v in $Y $rLC $K {
		if "`v'" ~= "" {
			local vars "`vars' `v'"
			}
				}
	global vars "`vars'"
	if $region == 1 {
		local region "region"
			}
	if $ownership == 1 {
		local ownership "ownership"
			}
	if "$report_age" == "yes" {
		local age "age_cls4"
			}
	global cut "sector10  `region' sz_cls5 `age' `ownership'"
	forvalues i=1(1) $mx {
		sum year if nyr == `i'
		local yr`i' = r(max)
		local order  "`order' yr`yr`i''"
		foreach v in $vars { 
						preserve
							collapse (sum) `v' [$wgt=wgt] if year == `yr`i''
							g variable = "`v'"
							g dimension = "all"
							g categories = 0
							g s_categories = ""
							ren `v' yr`yr`i''
							sort  variable dimension categories
							save "`v'`i'.dta", replace
						restore
								}
							}
	global order "`order'"
	forvalues i=1(1) $mx {
		sum year if nyr == `i'
		local yr`i' = r(max)
		foreach v in $vars { 
					foreach cut in $cut {
						sum `cut' if  nyr == `i'
						if r(N) > 0 {
							preserve
								collapse (sum) `v' if year == `yr`i'' & `cut' ~= . [$wgt=wgt], by(`cut')
								g variable = "`v'"
								g dimension = "`cut'"
								decode `cut', g(s_categories)
								ren `cut' categories
								ren `v' yr`yr`i''
								append using "`v'`i'.dta"
								sort  variable dimension categories 
								save "`v'`i'.dta", replace
							restore
									}
						if r(N) == 0 {
							preserve
								collapse (sum) `v' if year == `yr`i'' 
								g variable = "`v'"
								g dimension = "missing"
								g categories = .
								g s_categories = ""
								replace `v' = 0
								ren `v' yr`yr`i''
								append using "`v'`i'.dta"
								save "`v'`i'.dta", replace
							restore
									}
								}
							}
						}
	preserve
		foreach v in $vars {
				forvalues i=2(1) $mx {
					use "`v'`i'.dta", clear
					sort variable dimension categories 
					merge 1:1 variable dimension categories using "`v'1.dta", nogen
					save "`v'1.dta", replace
							}
						}
		foreach v in $vars  { 	
			if "`v'" ~= "N" {
				use "`v'1.dta", clear
				append using "N1.dta"
				order $order
				save "N1.dta", replace 
							}
						}
				foreach c in $order {
					la var `c' "`c'"
							}
				label drop _all
				g variabletit = ""
				vartitle
				g sort = "1" if variable == "N" 
				replace sort = "2" if variable == "L" 
				replace sort = "3" if variable == "$Y" 
				replace sort = "4" if variable == "$rLC" 
				replace sort = "5" if variable == "$K" 
				replace sort = "0" + sort if dimension == "all"
				g sort2 = 1 if dimension == "sector10"
				replace sort2 = 2 if dimension == "region"
				replace sort2 = 3 if dimension == "sz_cls5"
				replace sort2 = 4 if dimension == "age_cls4"
				replace sort2 = 5 if dimension == "ownership"
				tostring sort2, replace
				tostring categories, g(sort3)
				replace sort = sort + sort2 + sort3
				order sort variable variabletit 
				sort sort dimension categories
				drop sort*
				export excel	Tables_JDD_$CCC, firstrow(varlabels) sheet("Table3")   sheetmodify				
				forvalues i=1(1) $mx {	
					foreach v in $vars  { 	
							erase "`v'`i'.dta"
									}
								}
		restore	
	end
	
cap program drop factor_shares
program def factor_shares
	if $valueadded == 1 & $wages ~= 0 {
	preserve
		if $wages == 2 | $wages == 3 {
			local W "rLC"
				}
		else {
			local W "$rLC"
					}
		collapse (sum) rV `W' [$wgt=wgt], by(year)
		g capital_sh_va = 100*(rV - `W')/rV
		la var capital_sh_va "Capital share of Value Added"
		g labor_sh_va = 100*`W'/rV
		la var labor_sh_va "Labor share of Value Added"
		graph bar capital_sh_va labor_sh_va , over(year, sort((sum)1) label(angle(vertical) labsize(vsmall)))  ///																				
		$bar tit("${country}: Capital and Labor Shares of Value Added", color(black) size(medsmall)) ///
		stack  legend(lab(1 "Capital share of Value Added")  /// 
		lab(2 "Labor share of Value Added") row(2) size(vsmall) color(black) ) ytitle(%, size(small)) ylab(, labsize(vsmall))
		qui graph save "Fig`1'_factorsh_$CCC.gph", replace
		qui graph export "gr_png\Fig`1'_factorsh_$CCC.png", as(png) replace
		export excel using "Output_data_JDD_$CCC" , sheet("Fig`1'")  firstrow(varlabels) sheetmodify
	restore
					}
end
capture program drop bubbles
program define bubbles
			if $wages ~= 0 {
				preserve
					collapse (sum) $Yvar L $rLC if sector10~=. & (year == $Yvar_mnyr | year == $Yvar_mxyr) [$wgt=wgt], by(sector10 year)
					la var $Yvar "$Yvartit"
					la var L "Employment"
					la var $rLC "$rLCtit"
					g ${Yvar}_L=${Yvar}/L
					la var ${Yvar}_L "${prodvartit}"
					g ${rLC}_L=${rLC}/L
					la var ${rLC}_L "Average ${rLCtit}"
					egen Ltot=sum(L) if year==$Yvar_mxyr
					la var Ltot "Total employment"
					g shL = L/Ltot  if year == $Yvar_mxyr
					replace shL=round(L/Ltot*100,.1)
					la var shL "Employment share"
					sum shL
					g bubblelaba=string(shL) + "%" if shL!=. & (shL==r(max) | shL==r(min))
					la var bubblelaba "Employment share"
					global xaxisa "${rLC}_L"
					global xaxistita "${rLCtit} ($unit)"
					global bubblesa "Bubbles represent employment share $Yvar_mxyr"
					global subtit "${prodvartit}, ${rLCtit}, Employment"
					global xaxistitb "${rLCtit} change ($unit)"
					bys sector10 (year): g delta_yaxis=${Yvar}_L-${Yvar}_L[_n-1]
					la var delta_yaxis "${prodvartit} change"
					bys sector10 (year): g delta_xaxis = ${rLC}_L-${rLC}_L[_n-1]
					la var delta_xaxis "${rLCtit} change"
					bys sector10 (year): g bubble = L-L[_n-1] 
					la var bubble "Job creation"
					bys sector10 (year): g LPg=(${Yvar}_L-${Yvar}_L[_n-1])/${Yvar}_L[_n-1]
					la var LPg "${prodvartit} growth"
					bys sector10 (year): g LCg = (${rLC}_L-${rLC}_L[_n-1])/${rLC}_L[_n-1]
					la var LCg "${rLCtit} growth"
					bys sector10 (year): g Lg = (L-L[_n-1])/L[_n-1]
					la var Lg "Employment growth"
					replace bubble =round(bubble,0.01)	
					
					g bubbleb = abs(bubble)
					tostring bubbleb, g(bubbles)
					replace bubbles = substr(bubbles,1,2)
					sum bubbleb
					g bubbleblabb="ΔL" + "=" + bubbles if bubble ~=. & ( bubbleb==r(max) | bubbleb==r(min) )		
					global bubblesb "Bubbles represent employment change {it:BLUE} {it:{&Delta}L} is expansion {it:RED} {it:{&Delta}L} is reduction"
					count if bubble>=0 & bubble!=. 
					if r(N)>0 {
						global scatter1 "scatter delta_yaxis delta_xaxis [w=bubbleb] if bubble>0, mcolor(navy) msymbol(circle_hollow) ||"
						global scatter1_lab "scatter delta_yaxis delta_xaxis if bubble>0, mlabel(bubbleblabb) mlabposition(12)  msize(*2.5)  mlabsize(vsmall) mcolor(none) mlabcolor(navy) ||"
									}
					else {
						global scatter1 " "
						global scatter1_lab " "
							}
					count if bubble<0 & bubble!=. 
					if r(N)>0 {
						global scatter2 "scatter delta_yaxis delta_xaxis [w=bubbleb] if bubble<0, mcolor(cranberry) msymbol(circle_hollow) ||"
						global scatter2_lab "scatter delta_yaxis delta_xaxis if bubble<0, mlabel(bubbleblab) mlabposition(12)  msize(*2.5)  mlabsize(vsmall) mcolor(none) mlabcolor(navy) ||"
									}				
					else {
						global scatter2 ""
						global scatter2_lab ""
									}	
				order year sector10 $Yvar L $rLC bubble delta_yaxis delta_xaxis Lg LPg LCg
								}
							
		if $wages == 0 {
			preserve
				collapse (sum) $Yvar L if sector10~=. & (year == $Yvar_mnyr | year == $Yvar_mxyr) [$wgt=wgt], by(sector10 year)
					la var $Yvar "$Yvartit"
					la var L "Employment"
					g ${Yvar}_L=${Yvar}/L
					la var ${Yvar}_L "${prodvartit}"
					egen Ltot=sum(L) if year==$Yvar_mxyr
					la var Ltot "Total employment"
					g shL = L/Ltot  if year == $Yvar_mxyr
					replace shL=round(L/Ltot*100,.1)
					la var shL "Employment share"
					g bubblelaba=string(shL) + "%" if shL!=.
					la var bubblelaba "Employment share"
					global xaxisa "L"
					global xaxistita "Employment"	
					global xaxistitb "Employment Change"	
					global bubblesa "Bubbles represent employment share $Yvar_mxyr"
					global bubblesb "Bubbles represent employment share $Yvar_mxyr"
					g bubble=shL
					la var bubble "Employment share"
					g bubblelabb=bubblelaba
					la var bubblelabb "Employment share"
					bys sector10 (year): g delta_yaxis=${Yvar}_L-${Yvar}_L[_n-1]
					la var delta_yaxis "${prodvartit} change" 
					bys sector10 (year): g delta_xaxis = L-L[_n-1]
					la var delta_xaxis "Employment change"
					bys sector10 (year): g LPg=(${Yvar}_L-${Yvar}_L[_n-1])/${Yvar}_L[_n-1]
					la var LPg "${prodvartit} growth"
					bys sector10 (year): g Lg = (L-L[_n-1])/L[_n-1]
					la var Lg "Employment growth"
					global subtit "${Yvartit}, Employment"
					global scatter1 "scatter delta_yaxis delta_xaxis [w=bubble], mcolor(navy) msymbol(circle_hollow) ||"
					global scatter1_lab "scatter delta_yaxis delta_xaxis, mlabel(bubblelabb) mlabposition(12)  msize(*2.5)  mlabsize(vsmall) mcolor(none) mlabcolor(navy) ||"
					global scatter2 ""
					global scatter2_lab ""
					order year sector10 $Yvar L  bubble delta_yaxis delta_xaxis Lg LPg 
							}
		if $manuf == 0 {
				la def sector10_labshort 1 "Agr" 2 "MinUtil" 3 "Food" 4 "TextApp" 5 "Metals" 6 "M_Other" 7 "Constr" 8 "WholeS" 9 "TrCoStFin" 10 "S_Other", modify
							}
		if $manuf == 1 {
				la def sector10_labshort 1 "Food" 2 "TextApp" 3 "Print" 4 "Chem" 5 "Plastics" 6 "Constr" 7 "Metals" 8 "Equip" 9 "Furnit" 10 "Other", modify
							}
		la val sector10 sector10_labshort
		
		scatter ${Yvar}_L $xaxisa [w=shL] if year == $Yvar_mxyr, mcolor(navy) msymbol(circle_hollow) || ///
		scatter ${Yvar}_L $xaxisa if year == $Yvar_mxyr, mlabel(bubblelaba) mlabposition(12)  msize(*2.5)  mlabsize(vsmall) mcolor(none) mlabcolor(navy) || ///
		scatter ${Yvar}_L $xaxisa if year == $Yvar_mxyr, mlabel(sector10) mlabposition(6)  msize(*2.5)  mlabsize(vsmall) mcolor(none) mlabcolor("0 173 228") ///	
		xlabel(, labsize(small) grid) ylabel(, labsize(small) grid) legend(off) ///
		xline(0, lpattern(dash) lcolor(black)) yline(0, lpattern(dash) lcolor(black)) ///
		xtitle("$xaxistita", size(small)) ytitle("${prodvartit} ($unit)", size(small)) ///
		note("$bubblesa" "$datasource" "{it:WB-Job Diagnostics}", size(vsmall)) ///
		title("$country ($Yvar_mxyr)", size(medsmall)) subtitle("$subtit", size(small))
		qui graph save "fig`1'a_bubble_$CCC.gph", replace
		qui graph export "gr_png\fig`1'a_bubble_$CCC.png", as(png) replace

		$scatter2 $scatter2_lab $scatter1 $scatter1_lab || ///
		scatter delta_yaxis delta_xaxis ,  ///
		mlabel(sector10) mlabposition(6)  msize(*2.5)  mlabsize(vsmall) mcolor(none) mlabcolor("0 173 228") ///
		xlabel(, labsize(small) grid) ylabel(, labsize(small) grid) legend(off) ///
		xline(0, lpattern(dash) lcolor(black)) yline(0, lpattern(dash) lcolor(black)) ///
		xtitle("$xaxistitb", size(small)) ytitle("$prodvartit change ($unit)", size(small)) ///
		note("$bubblesb" "$datasource" "{it:WB-Job Diagnostics}", size(vsmall)) ///
		title("${country}: Changes ($Yvar_mnyr to $Yvar_mxyr)", size(medsmall)) subtitle("$subtit", size(small))
		qui graph save "Fig`1'b_bubble_$CCC.gph", replace
		qui graph export "gr_png\Fig`1'b_bubble_$CCC.png", as(png) replace
		gr combine "Fig`1'a_bubble_$CCC.gph" "Fig`1'b_bubble_$CCC.gph", cols(2) 
		graph save "Fig`1'a&b_bubble_$CCC.gph", replace
		graph export "gr_png\Fig`6'a&b_bubble_$CCC.png", as(png) replace
		drop bubble*
		format ${Yvar}_L $xaxisa delta_yaxis delta_xaxis %12.0f
		export excel using "Output_data_JDD_$CCC" , sheet("Fig`1'")  firstrow(varlabels) sheetmodify
	restore
end 

cap program drop prod2
program def prod2
	preserve
		drop if PROD2 == .
		keep if year == $Yvar_mnyr | year == $Yvar_mxyr
		collapse (sum) N $Yvar L if PROD2 ~= ., by(PROD2 year)
		global Ltit "Employment"
		if "$prodvar" == "" {
			global Y_Ltit ""
						}
		if "$prodvar" ~= "" {
			local Y_Lunit "$unit" 
			g Y_L=${Yvar}/L
			global Y_Ltit "Labor Productivity"
				}
		foreach v in Y_L L {
			drop if `v' == 0
			g `v'$Yvar_mnyr = `v' if year == $Yvar_mnyr
			la var `v'$Yvar_mnyr "$Yvar_mnyr"
			local  `v'$Yvar_mnyr "`v'$Yvar_mnyr"
			g `v'$Yvar_mxyr = `v' if year == $Yvar_mxyr
			la var `v'$Yvar_mxyr "$Yvar_mxyr"
			local  `v'$Yvar_mxyr "`v'$Yvar_mxyr"
				}
		g out = .
		g N50 = 1 if N < 50
		foreach v in Y_L L {
			sum ``v'$Yvar_mnyr' 
			local m``v'$Yvar_mnyr' = r(mean)
			local sd``v'$Yvar_mnyr' = r(sd)
			sum ``v'$Yvar_mxyr' 
			local m``v'$Yvar_mxyr' = r(mean)
			local sd``v'$Yvar_mxyr' = r(sd)
			replace out = 1 if (``v'$Yvar_mnyr' < (`m``v'$Yvar_mnyr'' - 4*`sd``v'$Yvar_mnyr'')) & ``v'$Yvar_mnyr' ~= .
			replace out = 1 if (``v'$Yvar_mxyr' > (`m``v'$Yvar_mxyr'' + 4*`sd``v'$Yvar_mxyr'')) & ``v'$Yvar_mxyr' ~= .
			sum ``v'$Yvar_mnyr' if out ~= 1 & N50 ~= 1
			global `v'mxx = r(max)
			global `v'mnx = r(min)
			sum ``v'$Yvar_mxyr' if out ~= 1 & N50 ~= 1
			global `v'mxy = r(max)
			global `v'mny = r(min)
			global `v'mx = max($`v'mxx, $`v'mxy)
			global `v'mn = min($`v'mnx ,$`v'mny)
					}
		sort PROD2
		merge m:1 PROD2 using "${input}\PROD2_label.dta", nogen keep(1 3)
		foreach v in  sector10 sector5 {
			decode `v', g(`v's)
					}
		collapse (mean) Y_L$Yvar_mnyr Y_L$Yvar_mxyr L$Yvar_mnyr  L$Yvar_mxyr (sum) N50 out, by(PROD2 PROD2_label lashort sector10s sector5s)
		la var Y_L$Yvar_mnyr "${prodvartit} $Yvar_mnyr" 
		la var Y_L$Yvar_mxyr "${prodvartit} $Yvar_mxyr" 
		la var L$Yvar_mnyr  "Employment $Yvar_mnyr"
		la var L$Yvar_mxyr "Employment $Yvar_mxyr"
		g Nless50 = "*" if N50 == 1 | N50 == 2
		la var Nless50 "less than 50 firms"
		g outlier = "*" if out == 1 | out == 2
		g LP_change = Y_L$Yvar_mxyr - Y_L$Yvar_mnyr
		la var LP_change "${prodvartit} change"
		g LPg = (Y_L$Yvar_mxyr - Y_L$Yvar_mnyr)/Y_L$Yvar_mnyr
		la var LPg "${prodvartit} growth"
		g L_change = L$Yvar_mxyr - L$Yvar_mnyr
		la var L_change "Employment change"
		g Lg = (L$Yvar_mxyr - L$Yvar_mnyr)/L$Yvar_mnyr
		la var Lg "Employment growth"
		order PROD2 PROD2_label lashort sector10s sector5s Y_L$Yvar_mnyr Y_L$Yvar_mxyr LP_change LPg L$Yvar_mnyr L$Yvar_mxyr L_change Lg 
		foreach v in  Y_L L {
			if "`v'" == "L" & "$prodvar" ~= "" {
				local t "a"
						}
				if "`v'" == "Y_L" {
				local t "b"
						}
			twoway (scatter `v'$Yvar_mnyr `v'$Yvar_mxyr  if outlier ~= "*" & Nless50 ~= "*", ///
			mlabel(PROD2) msymbol(Th) msize(tiny) mc(navy) mlabs(vsmall)) ///
			(function y=x, range(${`v'mx} ${`v'mn}) lcolor(cranberry) lwidth(thin)) , ///
			title("${country}: ${`v'tit}", size(medium)) subtit("Change: $Yvar_mnyr - $Yvar_mxyr", size(medsmall)) ///
			ytit("${`v'tit} ``v'unit' $Yvar_mnyr",size(small)) ylab(,labsize(vsmall)) xtit("${`v'tit} ``v'unit'  $Yvar_mxyr", size(small)) ///
			xlab(,labsize(vsmall)) legend(label(1 "sector") label(2 "$Yvar_mnyr=$Yvar_mxyr") size(vsmall)) /// 
			note("Sector ommited if N<50 or outlier (mean +/- 4sd)" "$datasource" "{it:WB-Job Diagnostics}", size(vsmall)) 
			qui graph save  "Fig`1'`t'_scatter_2d_$CCC.gph", replace
			qui graph export  "gr_png\Fig`1'`t'_scatter_2d_$CCC.png", as(png) replace
						}
			if "$prodvar" ~= "" {
				gr combine "Fig`1'a_scatter_2d_$CCC.gph" "Fig`1'b_scatter_2d_$CCC.gph" ,				
				qui graph save "Fig`1'_scatter_2d_$CCC.gph", replace
				qui graph export "gr_png\Fig`1'_scatter_2d_$CCC.png", as(png) replace
						}
		cap la drop _all
		drop N50 out
		export excel using "Output_data_JDD_$CCC" , sheet("Fig`1'") firstrow(varlabels) sheetmodify	
	restore
end
capture program drop decompositions_sector
program def decompositions_sector
	preserve
		keep if year==$Yvar_mnyr | year==$Yvar_mxyr
		drop if `1' ==. | `3' ==. | sector10 == .
		collapse (sum) `1' `3' [$wgt=wgt], by(year sector10)
		egen Px = sum(`1'), by(year)
		egen `3't = sum(`3'), by(year)
		g `1'_`3'_agg_$Yvar_mxyr= Px/`3't
		g sh`3'=`3'/`3't
		g aux1=`1'_`3'_agg_$Yvar_mxyr if year==$Yvar_mnyr
		egen `1'_`3'_agg_$Yvar_mnyr=max(aux1)
		g d_Px= `1'_`3'_agg_$Yvar_mxyr - `1'_`3'_agg_$Yvar_mnyr
		g `1'_`3'=`1'/`3'
		bys sector10 (year): g within = sh`3'[_n-1]*(`1'_`3'-`1'_`3'[_n-1])
		bys sector10 (year): g between = `1'_`3'*(sh`3'-sh`3'[_n-1])
		collapse (sum) d_Px within between if year==$Yvar_mxyr, by(sector10)
		gr hbar (mean) within between, o(sector10, label(labsize(vsmall)))  ///
		title("${country}:Labor Productivity Change", size(medium)) subtit("Decomposition ($Yvar_mnyr to $Yvar_mxyr)", size(medsmall)) ytit("`2' (LCU)", size(small)) ylab(#6, labsize(vsmall)) /// 
		note("employment weighted" "$datasource" "{it:WB-Job Diagnostics}", size(vsmall)) legend(rows(1)  keygap(*.5) symxsize(*.5) bmargin(vsmall) size(small)) stack  ///
		legend(row(2) lab(1 "within") lab(2 "between") size(small)) bar(1, color("0 35 69")) bar(2, color("0 173 228")) 
		qui graph save "Fig`4'_decomp_$CCC.gph",  replace
		qui graph export "gr_png\Fig`4'_decomp_$CCC.png",  as(png) replace
		la var d_Px "Productivity Change"
		la var within "" 
		la var between "" 
		export excel using "Output_data_JDD_$CCC" , sheet("Fig`4'") firstrow(varlabels) sheetmodify	
	restore
end
cap program drop trends
program def trends
	preserve
		sum year if $K ~=. 
		loca mnyrK = r(min)
		collapse (sum) $K L [$wgt = wgt] if year >= `mnyrK' & sector3 ~= ., by(sector3 year)
		la var L "total employment"
		la var $K "total $rKtit"
		g ln$K = log($K)
		la var $K "total $rKtit (log)"
		g K_L = $K/L
		la var K_L "capital/labor"
		g lnK_L = log($K/L)
		la var lnK_L "capital/labor (log)"
		sum year if ln$K ~= .
		local mnyr = r(min)
		local mxyr = r(max)
		local lpatt1 "lpattern(solid)"
		local lpatt2 "lpattern(longdash)"
		local lpatt3 "lpattern(shortdash)"
		local lc1 "lcolor("0 35 69")" 
		local lc2 "lcolor("0 173 228")"
		local lc3 "lcolor("0 96 104")"
		local lw "lw(medium)"
		decode sector3, g(category_s)		
		foreach v in lnK_L ln$K {
			if "`v'" == "lnK_L" {
				local t "a"
				local Ktit "Capital-Labor ratio"
				la var `v' "`Ktit'"
					}
			if "`v'" == "ln$K" {
				local t "b"
				local Ktit "Capital (log)"
				la var `v' "`Ktit'"
				}
			sum sector3
			local s3mn = r(min)
			if $byyear > 2 {
					levelsof category_s, local (sc)
					local graph ""
					local lab ""
					local k = `s3mn'
					foreach j of local sc {
						su `v' if sector3 == `k'
						local N = r(N)
						if `N' > 0 {
							local graph "`graph' (line `v' year if sector3 == `k', sort `lc`k'' `lw' `lpatt`k'')"
							local lab "`lab'  lab(`k' "`j'")"
							}
						local k = `k' + 1
										}
					graph twoway `graph', legend(`lab' size(small)) ti("${country}: `Ktit'", size(medium)) ///
					yti("`Ktit' $unit", size(vsmall))  xti(,size(small))  xlab(, labsize(vsmall)  valuelabel)  ///
					xsc(r(`mnyr' `mxyr')) xlabel(`mnyr' (1) `mxyr',angle(vertical))  /// 
					note("$datasource" "{it:WB-Job Diagnostics}", size(vsmall) color(black))
					qui graph save "Fig`1'`t'_Ktrend_$CCC.gph",  replace
					qui graph export "gr_png\Fig`1'`t'_Ktrend_$CCC.png", as(png) replace						
												}
			if $byyear == 2 {
				graph bar `v'  if year==`mnyr' | year==`mxyr' , over(year, label(angle(vertical) labsize(vsmall))) ///
				over(sector3s, label(angle(horizontal) labsize(vsmall))) ///
				$bar title("${country}: `Ktit'", color(black) size(medium)) legend(size(vsmall) color(black))  /// 
				yti("`Ktit' $unit", size(vsmall)) ylab(, labsize(vsmall)) /// 
				note("$datasource" "{it:WB-Job Diagnostics}", size(vsmall) color(black))
				qui graph save "Fig`1'`t'_Ktrend_$CCC.gph",  replace	
				qui graph export "gr_png\Fig`1'`t'_Ktrend_$CCC.png",  as(png) replace	
								}
							}
		gr combine "Fig`1'a_Ktrend_$CCC.gph" "Fig`1'b_Ktrend_$CCC.gph"
		qui graph save "Fig`1'_Ktrend_$CCC.gph",  replace	
		qui graph export "gr_png\Fig`1'_Ktrend_$CCC.png",  as(png) replace
		drop category_s
		export excel using "Output_data_JDD_$CCC" , sheet("Fig`1'")  firstrow(varlabels) sheetmodify	
	restore
end

cap program drop ypc10
program def ypc10
	foreach var in $prodvar $avwage {
		preserve
				keep if year == $Yvar_mnyr | year == $Yvar_mxyr
				keep `var' year
				g `var'_s = .
				g `var'_e = .
				xtile xt`var'_s = `var' if `var' >= 0 & year == $Yvar_mnyr, n(10)
				xtile xt`var'_e = `var' if `var' >= 0 & year == $Yvar_mxyr, n(10)
				sum `var' if  `var' < 0 & year == $Yvar_mnyr
				local Nstart = r(N)
				sum `var' if  `var' < 0 & year == $Yvar_mxyr
				local Nend = r(N)
				forval i = 1(1)10 {
					replace `var'_s = `var' if xt`var'_s == `i' & year == $Yvar_mnyr
					replace `var'_e = `var' if xt`var'_e == `i' & year == $Yvar_mxyr
								}	
				g decile = xt`var'_s if year == $Yvar_mnyr
				replace decile = xt`var'_e if year == $Yvar_mxyr
				collapse (mean) `var'_s `var'_e, by(decile)
				sort decile
				merge 1:1 decile using "$input\JDD_ypc10_$CCC.dta", nogen
				drop if decile== 99
				sort decile
				save "$input\JDD_ypc10_$CCC.dta", replace
			restore
					}
			preserve
			use "$input\JDD_ypc10_$CCC.dta", clear
			la var ${prodvar}_s "${prodvartit} $Yvar_mnyr"
			la var ${prodvar}_e "${prodvartit} $Yvar_mxyr"
			la var ${avwage}_s "${rwagetit} $Yvar_mnyr"
			la var ${avwage}_e "${rwagetit} $Yvar_mxyr"
			export excel using "Output_data_JDD_$CCC" , sheet("Fig`1'") firstrow(varlabels) sheetmodify	
			foreach var in $prodvar $avwage {	
			
			if "$prodvar"  == "LPV" {
				sum ${prodvar}_s if ${prodvar}_s < 0 
				local N_start = r(N)
				if r(N) > 0 {
					local note1 "$prodvar <0 in $Yvar_mnyr `N_start' obs."
						}
				sum ${prodvar}_e if ${prodvar}_e < 0 
				local N_end = r(N)	
				if r(N) > 0 {
					local note2 "$prodvar <0 in $Yvar_mxyr `N_start' obs."
						}
						}
			if "$avwage" ~= "" {
						local t "a"
								}
				if "`var'" == "$prodvar" {
						local vartit "$prodvartit"
									}
				if "`var'" == "$avwage" {
						local t "b"
						local vartit "$rwagetit"
									}
				graph hbar `var'_s `var'_e, over(decile, label(labsize(vsmall))) ///
				$bar title("${country}: Mean `vartit'", color(black) size(medium)) /// 				
				subtitle("By Deciles ($Yvar_mnyr - $Yvar_mxyr)", color(black) size(medsmall)) ///  
				legend(lab(1 "$Yvar_mnyr") lab(2 "$Yvar_mxyr") size(small) color(black)) /// 
				ylab(,labsize(vsmall)) ytitle("`vartit' $unit", size(small)) /// 
				note("`note1'" "`note2'" "$datasource" "{it:WB-Job Diagnostics}", size(vsmall))
				qui graph save "Fig`1'`t'_ypc10_$CCC.gph",  replace	
				qui graph export "gr_png\Fig`1'`t'_ypc10_$CCC.png", as(png) replace
				if "`var'" == "$avwage" {
					gr combine "Fig`1'a_ypc10_$CCC.gph" "Fig`1'b_ypc10_$CCC.gph" , 
					graph save "Fig`1'_ypc10_$CCC.gph", replace
					graph export "gr_png\Fig`1'_ypc10_$CCC.png", as(png) replace
							}
						}
			erase "$input\JDD_ypc10_$CCC.dta"
	restore
end

cap program drop densityyr
program def densityyr
	foreach var in $prodvar $avwage {
			if  "$avwage" ~= "" {
				local t "a"
						}
			if "`var'" == "$prodvar" {
				local vartit "$prodvartit"
							}
			if "`var'" == "$avwage" {
				local t "b"
				local vartit "$rwagetit"
							}
			cap drop x1 f1_*
			kdensity ln`var' if year==$Yvar_mnyr,   nogr g(x1 f1_1) w(0.1) 
			la var f1_1 "$Yvar_mnyr"
			kdensity ln`var' if year == $Yvar_mxyr, nogr g(f1_2) at(x1)  w(0.1) 
			la var f1_2 "$Yvar_mxyr"
			twoway (line f1_1  x1,  lpattern(solid) lcolor("0 35 69")) (line f1_2  x1, lpattern(longdash) lcolor("0 173 228")), ///
			legend(label(1 "$Yvar_mnyr") label(2 "$Yvar_mxyr") size(small)) /// 
			ytit(density) title("${country}: `vartit'", size(medium)) note("$datasource" "{it:WB-Job Diagnostics}", size(vsmall)) 
			qui graph save "Fig`1'`t'_densyr_$CCC.gph", replace
			qui graph save "Fig`1'`t'_densyr_$CCC.gph", replace
			drop x1 f1_*
			if "`var'" == "$avwage" {
				gr combine "Fig`1'a_densyr_$CCC.gph" "Fig`1'b_densyr_$CCC.gph"
				qui graph save "Fig`1'_densyr_$CCC.gph", replace
				qui graph export "gr_png\Fig`1'_densyr_$CCC.png", as(png) replace
							}
						}
end	

cap program drop deltayr
program def deltayr
	preserve
		collapse (mean)  ${prodvar} rwage  [$wgt=wgt] if (year==$Yvar_mnyr | year == $Yvar_mxyr) & sector10 ~= . , by(sector10 year)
		la var ${prodvar} "Mean ${prodvartit} $unit"
		la var rwage "Mean wage $unit"
		export excel using "Output_data_JDD_$CCC" , sheet("Fig`1'") firstrow(varlabels) sheetmodify	
		foreach var in $prodvar $avwage {
			if "`var'"== "$prodvar" & "$avwage" ~= "" {
				local t "a"
						}
			if "`var'" == "$prodvar" {
				local vartit "$prodvartit"
							}
			if "`var'" == "$avwage" {
				local vartit "Wage"
				local t "b"
							}
		gr bar `var', o(year, label(labsize(vsmall))) o(sector10, label(angle(45) labsize(vsmall))) /// 
		title("${country}: `vartit'", size(medium)) subtit("(firm average)", size(small)) /// 
		ytit("`vartit' ($unit)", size(small)) ylab(#6, labsize(vsmall)) /// 
		legend(rows(1) size(vsmall)  keygap(*.5) symxsize(*.5) bmargin(vsmall) ) asyvars bargap(5) $bar /// 
		note("$datasource" "{it:WB-Job Diagnostics}", size(vsmall)) 
		qui graph save "Fig`1'`t'_deltayr_$CCC.gph", replace
		qui graph export "gr_png\Fig`1'`t'_deltayr_$CCC.png", as(png) replace

		if "`var'" == "$avwage" {
			gr combine "Fig`1'a_deltayr_$CCC.gph" "Fig`1'b_deltayr_$CCC.gph", cols(2)
			graph save "Fig`1'_deltayr_$CCC.gph" , replace
			graph export "gr_png\Fig`1'_deltayr_$CCC.png", as(png) replace
							}
						}
		restore
end 
		
cap program drop densityX
program def densityX
    local wgt_int=round(wgt)
	cap drop x1 f1_*
	sum year if `1' ~= .
	local mxyr = r(max)
	local l1 "lw(medthick) lpattern(solid) lcolor("0 35 69")"
	local l2 "lw(medthick) lpattern(longdash) lcolor("0 173 228")"
	local l3 "lw(medthick) lpattern(shortdash) lcolor("0 96 104")"
	sum `2' if `1' ~= .
	local mnx = r(min)
	kdensity `1' if `2' == `mnx'  & year==`mxyr' [aw=`wgt_int'],   nogr g(x1 f1_1) w(0.1) 
	local gr "(line f1_1  x1,  `l`mnx'')"
	local x = `mnx' + 2
	la var f1_1 "``x''"
	local k = `mnx' + 1
	forval i = `k'(1)3 {
		sum `1' if `2' == `i'
		if r(N) > 0 {
			kdensity `1' if `2' == `i'  & year==`mxyr' [aw=`wgt_int'],   nogr g(f1_`i') at(x1)  w(0.1) 
			local gr "`gr' (line f1_`i'  x1, `l`i'')"
			local x = `i' + 2
			la var f1_`i' "``x''"
				}
			}
	twoway `gr', ytit(density) title("${country}: `6'", size(medium)) ///
	subtitle("(`mxyr')", size(medsmall)) legend(label(1 "`3'") label(2 "`4'") label(3 "`5'") size(small)) /// 
	note("$datasource" "{it:WB-Job Diagnostics}", size(vsmall))
	graph save "Fig`7'_dens_`1'_`2'_$CCC.gph",  replace
	graph export "gr_png\Fig`7'_dens_`1'_`2'_$CCC.png",  as(png) replace
	drop x1 f1_*
end

cap program drop meanLPwage
program def meanLPwage
		sum ln$prodvar
		local min1 = r(min)
		local mx1=r(max)
		sum lnrwage
		local min2 = r(min)
		local mx2=r(max)
		global mx = max(`mx1', `mx2')
		global mn = min(`min1', `min2')
		twoway (scatter ln$prodvar  lnrwage if year==$lyear & sector3 == 2, mc(navy)) /// 
		(scatter ln$prodvar  lnrwage if year==$lyear & sector3 == 3, mc(cranberry)) (function y=x, range($mn $mx) lcolor(cranberry) lwidth(thin))  , ///
		tit("${country}: Labor Productivity and Wage ($lyear)", size(medium)) subtit("Firm Average", size(medsmall))  ///
		ytit("$lnprodvartit ($unit)",size(small)) xtit("log Wage  ($unit)", size(small)) ylab(,labsize(small)) xlab(,labsize(small)) ///		
		legend(lab(1 "Manufacturing") lab(2 "Services") lab(3 "LP=Wage") size(small) row(3) ) /// 
		note("$datasource" "{it:WB-Job Diagnostics}", size(vsmall))
		qui graph save "Fig`1'_PWi_$CCC.gph", replace
		qui graph export "gr_png\Fig`1'_PWi_$CCC.png", as(png) replace
end
cap program drop entry
program def entry						
	cap g Len = L if age == 1
	cap g entry = (age==1) if age ~= .
	if $byyear <2 {
		local yr "($endyr)"
			}
	if $byyear >=2 {
		local stack "stack"
		local over "o(year,  label(labsize(small)  angle(vertical)))"
			}
	preserve
		decode `2', g(`2'_s)
		collapse (sum)  Len entry, by(year `2' `2'_s)
		la var Len "Employment at entry"
		la var entry "N. firms entering"
		egen entry_tot = sum(entry), by(year)
		la var entry_tot "Total N. firms entering"
		egen Len_tot= sum(Len), by(year)
		la var Len_tot "Total employment at entry"
		g entry_rate = entry/entry_tot
		la var entry_rate "Entry rate"
		g Len_rate = Len/Len_tot
		la var Len_rate "Employment rate"
		gr bar (sum) entry_rate, o(`2') `over' ///
		subtitle("${country}: Entry", size(medsmall)) ytit("%", size(small)) ylab(#6, labsize(vsmall)) /// 
		legend(size(small)  row(4) keygap(*.5) symxsize(*.5) bmargin(vsmall)) `stack' /// 
		asyvars  $bar note("Denominator total entry" "$datasource" "{it:WB-Job Diagnostics}", size(vsmall)) 
		qui graph save "Fig`1'a_entry_$CCC.gph", replace
		qui graph export "gr_png\Fig`1'a_entry_$CCC.png", as(png) replace
		gr bar (sum) Len_rate, o(`2') `over' ///
		subtitle("${country}: Employment at Entry", size(medsmall)) ytit("%", size(small)) ylab(#6, labsize(vsmall)) /// 
		legend(size(small) row(4)  keygap(*.5) symxsize(*.5) bmargin(vsmall)) `stack' /// 
		asyvars  $bar note("Denominator total employment at entry" "$datasource" "{it:WB-Job Diagnostics}", size(vsmall))
		qui graph save "Fig`1'b_entry_$CCC.gph",  replace
		qui graph export "gr_png\Fig`1'b_entry_$CCC.png", as(png) replace
		cap la drop _all
		sort year `2'
		order year `2' `2'_s
		export excel using "Output_data_JDD_$CCC" , sheet("Fig`1'") firstrow(varlabels) sheetmodify		
		gr combine "Fig`1'a_entry_$CCC.gph" "Fig`1'b_entry_$CCC.gph", cols(2) /// 
		title("`yr'", size(medium)) 
		qui graph save "Fig`1'_entry_`2'_$CCC.gph" , replace
		qui graph export "gr_png\Fig`1'_entry_`2'_$CCC.png" , as(png) replace
	restore
end

qui do "$dofiles\regsave.do"

cap program drop regvars
program def regvars
	if "`1'" ~= "exit" {
		global r2 r2
				}
	if "`1'" == "exit" {
	global r2 r2_p
				}
	local szd ""
		local k =2 
		foreach i in sz_10to19 sz_20to99 sz_100to499 sz_500plus {
			sum id if sz_cls5 == `k'
			local N = r(N)
			if `N' >= 50 {
				cap g `i' = (sz_cls5 == `k') if sz_cls5 ~= .
				local szd "`szd' `i'"
								}
			local k = `k' +1
						}
	global sized "`szd'"
	if "$datatype"== "panel" {
	sort id year
	tsset id year
		cap g Lav = round((L+l.L)/2) if L~=. & l.L ~= .
		la var Lav "Average size"
		cap g lnLav = log(Lav)
		la var Lav "Average size (log)"

		cap g sza_cls5=irecode(Lav,9,19,99,499,.)
		replace sza_cls5=. if Lav==0
		recode sza_cls5 0=1 1=2 2=3 3=4 4=5 
		la define sz_cls5  1 "size 1-9" 2 "size 10-19" 3 "size 20-99" 4 "size 100-499" 5 "size 500+", modify
		la val sza_cls5 sz_cls5
		
	local szad ""
	local k = 2
	foreach g in sza_10to19 sza_20to99 sza_100to499 sza_500plus {
		sum id if sza_cls5 == `k'
		local N = r(N)
		if `N' >= 50 {
		cap g `g' = (sza_cls5 == `k') if sza_cls5 ~= .
		local szad "`szad' `g'"
							}
		local k = `k' + 1	
					}		
	global sizead "`szad'"
			}
	local aged ""
	local k =2 
	foreach i in age_6to9 age_10to19 age_20plus {
		sum id if age_cls4 == `k'
		local N = r(N)
		if `N' >= 50 {
			cap g `i' = (age_cls4 == `k') if age_cls4 ~= .
			local aged "`aged' `i'"
							}
		local k = `k' +1
					}
	global aged "`aged'"	

	local own ""
	foreach i in fdi soe {
	 sum id if `i' == 1
	 local N = r(N)
		if `N' >= 50 {
			local own "`own' `i'"
							}
						}
	global own "`own'"
	local region ""
	cap drop regions
	if $region == 1 {
		decode region, g(regions)
		preserve
			keep if region==1
			local reg1 = regions[1]
			global reg1 `reg1'
		restore
		levelsof regions, local(Reg)
		foreach j of local Reg {
			forval i = 2(1)$mxreg {
				sum id if region == `i' & regions == "`j'"
				local N = r(N)
				if `N' >= 50 {
						cap g `j' = (regions == "`j'") if region ~= . 
						local region "`region' `j'"
									}
								}
							}
						}
	global regions "`region'"			
	local sector10 ""
	cap drop sector10s
	if $manuf == 0  {
		decode sector10, g(sector10s)
		levelsof sector10s, local(Sec)
		foreach 	j of local Sec {
			forval i = 1(1)10 {
				sum id if sector10 == `i' & sector10 ~= 3 & sector10s == "`j'"
				local N = r(N)
				if `N' >= 50 {
						cap g `j' = (sector10s == "`j'") if sector10 ~= . 
						local sector10 "`sector10' `j'"
									}
								}
							}
						}
	global sector10 "`sector10'"		
	cap drop ${prodvar}q*
	tab ${prodvar}_quartile, g(LPq)
	global prodvarq "LPq2 LPq3 LPq4"
	forval i = 1(1)4 {
		la var LPq`i' "Labor productivity Q`i'"
			}
	la var lnrK "Capital (log)"
end

cap program drop multivariate
program def multivariate
	local lnK "ln$K"
	if "$K" == "" {
		local lnK ""
			}
	if "`1'" == "lnL" {
		global xvars "$aged $own $prodvarq $regions $sector10"
		reg lnL $xvars if year == $endyr, r
	    outreg2  using lnL_$CCC, dta title("Employment (log) $endyr") ct("employment (log)") replace
		global lnL lnL_$CCC
		preserve
			coefplot , xline(0) mlabel format(%9.2g) mlabposition(12) mlabgap(*1.5) mlabsize(vsmall)  mcolor("0 35 69") drop(_cons) /// 
			title("${country}: Determinants Employment", size(medium)) subtitle("$endyr", size(small)) ///
			ylabel(, labsize(vsmall)) xlabel(, labsize(vsmall)) /// 
			note("with respect to `3' `4' `5' `6' `7' `8'" "dropped if N<50" "$datasource" "{it:Job Diagnostics (SPJ)}" , size(vsmall))	
			qui graph save "Fig`9'_Lreg_$CCC.gph", replace
			qui graph export "gr_png\Fig`9'_Lreg_$CCC.png", as(png) replace
		restore
		}
	if "`1'" == "$prodvar"  {
		global xvars "$sized $aged $own `lnK' $regions $sector10"
		reg ln$prodvar $xvars if year == $Yvar_mxyr, r
		outreg2  using ${prodvar}_$CCC, dta title("${prodvartit} (log) -$endyr") ct("${prodvartit} (log)") replace
        
		if "$prodvar"=="LPQ" {
			global Preg LPQ_$CCC
				}
		if "$prodvar"=="LPV" {
			global Preg LPV_$CCC
				}	
		else {
			global Preg ""
			}
		preserve
			coefplot , xline(0) mlabel format(%9.2g) mlabposition(12) mlabgap(*1.5) mlabsize(vsmall)  /// 
			mcolor("0 35 69") drop(_cons) ylabel(, labsize(vsmall)) xlabel(, labsize(vsmall)) /// 
			note("with respect to `3' `4' `5' `6' `7' `8'" "dropped if N<50" "$datasource" "{it:Job Diagnostics (SPJ)}" , size(vsmall))	///
			title("${country}: Determinants ${prodvartit}", size(medium)) subtitle("$Yvar_mxyr", size(small)) 
			qui graph save "Fig`9'_Preg_$CCC.gph", replace
			qui graph export "gr_png\Fig`9'_Preg_$CCC.png", as(png) replace
		restore
				}
	if "`1'" == "rwage"  {
		sum year if rwage~= .
		local mxyr = r(max)
		global xvars "$sized $aged $own `lnK' $prodvarq $regions $sector10"
		reg lnrwage $xvars if year == `mxyr', r
		outreg2  using rwage_$CCC, dta title("Average wage (log) `mxyr'") ct("Average wage (log)") replace
		global rwage rwage_$CCC
		
		preserve
			coefplot , xline(0) mlabel format(%9.2g) mlabposition(12) mlabgap(*1.5) mlabsize(vsmall)  mcolor("0 35 69") /// 
			drop(_cons) ylabel(, labsize(vsmall)) xlabel(, labsize(vsmall)) ///
			note("with respect to `3' `4' `5' `6' `7' `8'" "dropped if N<50" "$datasource" "{it:Job Diagnostics (SPJ)}" , size(vsmall))	/// 		
			title("${country}: Determinants Wages", size(medium)) subtitle("`mxyr'", size(small)) 
			qui graph save "Fig`9'_Wreg_$CCC.gph", replace
			qui graph export "gr_png\Fig`9'_Wreg_$CCC.png", as(png) replace
		restore
				}
	if "$datatype" == "panel" {	
	sort id year
	if "`1'" == "${prodvar}g" {
		cap g ${prodvar}g = 2*($prodvar-l.$prodvar)/($prodvar+l.$prodvar) if $prodvar ~= . & l.$prodvar ~= .
		replace ${prodvar}g = 2 if age == 1 & $prodvar ~= . 
		replace ${prodvar}g = -2 if exit == 2 & $prodvar ~= . 
				}
	if "`1'" == "Lg" | "`1'" == "Wg" {		
		foreach p in  Lg Wg  {
			replace `p' = 2 if age == 1 & `p' ~= . 
			replace `p' = -2 if exit == 2 & `p' ~= . 
						}
				}
	if "`1'" == "exit" {
		global xvars "$sized $aged $own $prodvarq `lnK' $regions $sector10"
		xi: dprobit exit $xvars i.year , r
	    outreg2  using exit_$CCC, dta title("Exit")  addtext(Year Dummies, YES) replace
		global exit exit_$CCC
		preserve
			coefplot , keep ($xvars) xline(0) mlabel format(%9.2g) mlabposition(12) mlabgap(*1.5) ///
			mlabsize(vsmall)  mcolor("0 35 69") drop(_cons) ylabel(, labsize(vsmall)) ///
			xlabel(, labsize(vsmall)) note("with respect to `3' `4' `5' `6' `7' `8' " "dropped if N<50" "$datasource" "{it:Job Diagnostics (SPJ)}" , size(vsmall)) ///	 		
			title("${country}: Probability of Exit", size(medium)) 
			qui graph save "Fig`9'_exit_$CCC.gph", replace
			qui graph export "gr_png\Fig`9'_exit_$CCC.png", as(png) replace
		restore
			}	
	if "`1'" == "Lg"  {
		global xvars "$sizead $aged $own $prodvarq $regions $sector10"
		xi: reg Lg $xvars i.year if age > 1 & exit ~= 2, r
		outreg2  using Lg_$CCC, dta title("Labor Growth") ct("Employment growth") addtext(Year Dummies, YES) replace
		global Lg Lg_$CCC
		preserve
			coefplot , keep($xvars) xline(0) mlabel format(%9.2g) mlabposition(12) mlabgap(*1.5) mlabsize(vsmall)  ///
			mcolor("0 35 69") drop(_cons) ylabel(, labsize(vsmall)) xlabel(, labsize(vsmall)) ///
			note("with respect to `3' `4' `5' `6' `7' `8' " "dropped if N<50" "$datasource" "{it:Job Diagnostics (SPJ)}" , size(vsmall))	/// 		
			title("${country}: Determinants Employment Growth", size(medium)) 
			qui graph save "Fig`9'_Lgreg_$CCC.gph", replace
			qui graph export "gr_png\Fig`9'_Lgreg_$CCC.png",as(png)  replace
		restore
			}
	if "`1'" == "${prodvar}g"  {
		global xvars "$sizead $aged $own  `lnK' $regions $sector10"
		xi: reg ${prodvar}g $xvars i.year  if age > 1 & exit ~= 2 , r
		outreg2  using ${prodvar}g_$CCC, dta title("Productivity Growth") ct("Productivity growth") addtext(Year Dummies, YES) replace
		if "$prodvar"=="LPQ" {
			global Pgreg LPQg_$CCC
				}
		if "$prodvar"=="LPV" {
			global Pgreg LPVg_$CCC
				}		
		preserve
			coefplot , keep($xvars) xline(0) mlabel format(%9.2g) mlabposition(12) mlabgap(*1.5) mlabsize(vsmall)  ///
			mcolor("0 35 69") drop(_cons) ylabel(, labsize(vsmall)) xlabel(, labsize(vsmall)) ///
			note("with respect to `3' `4' `5' `6' `7' `8' " "dropped if N<50" "$datasource" "{it:Job Diagnostics (SPJ)}" , size(vsmall))	/// 		
			title("${country}: Determinants Productivity Growth", size(medium)) 
			qui graph save "Fig`9'_Pg_reg_$CCC.gph", replace
			qui graph export "gr_png\Fig`9'_Pg_reg_$CCC.png", as(png) replace
		restore
			}							
	if "`1'" == "Wg"  {
		global xvars "$sizead $aged $own $prodvarq `lnK' $regions $sector10"
		xi: reg Wg $xvars i.year  if age > 1 & exit ~= 2, r
		outreg2  using Wg_$CCC, dta title("Wage Growth") ct("Wage growth") addtext(Year Dummies, YES) replace
		global Wg Wg_$CCC
		preserve
			coefplot , keep($xvars) xline(0) mlabel format(%9.2g) mlabposition(12) mlabgap(*1.5) mlabsize(vsmall)  mcolor("0 35 69") ///
			drop(_cons) ylabel(, labsize(vsmall)) xlabel(, labsize(vsmall)) ///
			note("with respect to `3' `4' `5' `6' `7' `8' " "$datasource" "dropped if N<50" "{it:Job Diagnostics (SPJ)}" , size(vsmall)) ///	 		
			title("${country}: Determinants Wages Growth", size(medium)) 
			qui graph save "Fig`9'_Wgreg_$CCC.gph", replace
			qui graph export "gr_png\Fig`9'_Wgreg_$CCC.png", as(png) replace
		restore
		}	
				}
end

cap program drop OP
program def OP
	preserve 
		cap g exit = 0
		drop if `1'==. | L ==. |exit==2
		egen s=sum(L), by(year `2') 
		egen s_k=sum(L), by(year)  
		g sh= L/s
		g sh_k = s/s_k
		egen b_p=mean(`1'), by(year `2') 
		egen b_sh=mean(sh), by(year `2') 
		g cov=(sh-b_sh)*(`1'-b_p)
		egen cov_p=total(cov), by(year `2')
		egen Yvar_t=total($Yvar), by(year `2')
		g Px=Yvar_t/s
		cap decode `2', g(sector_s)
		cap tostring `2', g(sector_s)
		collapse  (sum) cov (mean) Px b_p sh_k, by(year `2' sector_s)
		sum Px cov b_p
		g sector = "`2'" 
		la var sector "economic activity"
		if "`2'" == "PROD2" {
			replace sector = "isicv4-2d"
					}
		la var Px "Aggregate Productivity"
		la var cov "Covariance term"
		la var b_p "Unweighted Average Productivity"
		la var sh_k "Sector weight"
		order year sector sector_s Px b_p cov sh_k
		sort year sector
		if "`2'" == "PROD2" {
			sort PROD2
			merge m:1 PROD2 using "${input}\PROD2_label.dta", nogen
				}
		if "`2'" == "sector5"  | "`2'" == "sector10"  {
			append using "Table4_$CCC.dta"
					}
		save "Table4_$CCC.dta", replace
	restore
end 

capture program drop OPgraph
program def OPgraph
	preserve
		use "Table4_$CCC.dta", clear	
		keep if sector == "`1'"
		foreach var in Px cov  {
			g w_`var' = (sh_k*`var')
					}
		g wS_cov = w_cov*100/w_Px
		format wS_cov  %9.2f		
		qui sum year if w_Px  ~= .
		local mnyr = r(min)
		local mxyr = r(max)
		levelsof sector_s, local(tL)
		local f = 1
		foreach j of local tL {
			sum wS_cov if sector_s =="`j'"
			local min=round(r(min)-0.2, 0.2 )
			local max=round(r(max)+0.2, 0.2 )
			local dl=(`max'-`min')/4
			if	`max' < 0 {
				local max = 0
						}
			twoway line w_Px  year if sector_s=="`j'" & year >= `mnyr',  yaxis(1) sort ||  ///
			bar   wS_cov  year if sector_s=="`j'" & year >= `mnyr', barw(0.3) yaxis(2)  title("${country}: ${prodvartit}", size(medium) ) /// 
			subtitle("`j'", size(medsmall)) legend(label(1 "Aggregate Productivity") label(2 "Covariance %") size(small)) ///
			xlabel(`mnyr'(1)`mxyr', angle(vertical) labgap(2.5) labsize(small)) /// 
			ytitle("Labor Productivity ${units}", size (small) axis(1)) ytitle("Covariance", size (small) axis(2)) /// 
			note("employment weighted " "$datasource" "{it:Job Diagnostics (SPJ)}") ///
			ylabel( `min' (`dl') `max', axis(2) gmin gmax angle(horizontal) labsize(small) format( %9.2fc)) //// 
			ylabel(, axis(1) gmin grid angle(horizontal) labsize(small) format( %9.2fc) ) xtitle("") yline(0, axis(2))
			qui graph save "Fig`2'.`f'_OP_${CCC}.gph", replace
			qui graph export "gr_png\Fig`2'.`f'_OP_${CCC}.png", as(png) replace
			local f = `f' + 1
								}	
			if "`1'" == "sector10" {
			la var sector ""
				keep year sector sector_s Px b_p cov sh_k
				export excel using "Tables_JDD_$CCC" , firstrow(varlabels) sheet("Table4")  sheetmodify
				erase "Table4_$CCC.dta"
				}
		restore
end


cap program drop xpand
program def xpand
	cap g exit = (year == lyear &  lyear ~= $endyr) 
	replace exit = 1 if fyear == lyear & lyear== $startyr & age > 1 & age ~= .
	expand 2 if exit == 1
	bysort id (year): g expand = sum(exit) if exit == 1
	replace exit = 2 if expand == 2
	drop expand
	la def exit 0 "Continuous" 1 "Exit" 2 "Not in dataset", modify
	la val exit exit
	foreach var in year age { 
		capture replace `var'=`var'+1 if exit ==2
			}	
	drop if year > $endyr
	foreach var in L rS rV rK $prodvar {
			replace `var' = 0 if exit == 2
				}
end
cap program drop transitions
program def transitions
	capture postclose transit
	postfile transit str25(country period transition rowv) double(sz1 sz2 sz3 sz4 exit)  using "transitions_$CCC.dta", replace
	preserve
		g sz_cls4 = sz_cls5
		recode sz_cls4 5=4
		replace sz_cls4 = 0 if exit == 2
		drop if year > $endyr 
		sort id year
			forval i = 1(1)4 {
				forval j =0(1)4 {
					sum sz_cls4 if sz_cls4 == `i' & f4.sz_cls4 == `j'  & age == 1 
					local sz`j' = r(N)
						}
					post transit ("$country") ("$period") ("size at birth to age 5") ("szi`i'") (`sz1') (`sz2') (`sz3') (`sz4') (`sz0') 
							}				
			sort id year
			forval i = 1(1)4 {
				forval j =0(1)4 {
					sum sz_cls4 if sz_cls4 == `i' & f3.sz_cls4 == `j' 
					local sz`j' = r(N)
						}
					post transit ("$country")  ("$period") ("size t to t+3") ("sz`i'") (`sz1') (`sz2') (`sz3') (`sz4') (`sz0') 
							}
		postclose transit
		use "transitions_$CCC.dta", clear
		egen total = rsum(sz1 sz2 sz3 sz4 exit )
		g exit_pc = .
		g size = . 
		forval i = 1(1)4 {
			g sz`i'_pc = .
			replace size= `i' if rowv == "szi`i'" | rowv == "sz`i'"
			replace exit_pc = exit*100/total if (rowv == "szi`i'" |  rowv == "sz`i'")  & size == `i'
					}
			forval i = 1(1)4 {
				forval j = 1(1)4 {
					replace sz`j'_pc = sz`j'*100/total if (rowv == "szi`i'" |  rowv == "sz`i'") & size == `i'
								}
						}	
		la def sz_cls4 0 "exit" 1 "1-9" 2 "10-19" 3 "20-99" 4 "100+", modify
		la val size sz_cls4 
		la var transition "transition"
		keep country period transition size *pc
		order country  period transition size sz1_pc-sz4_pc exit_pc
		egen total_pc = rsum(exit_pc sz1_pc sz2_pc sz3_pc sz4_pc)
		la var sz1_pc "sz 1-9"
		la var sz2_pc "sz 10-19"
		la var sz3_pc "sz 20-99"
		la var sz4_pc "sz 100+"
		format *pc %9.2f
		export excel using "Tables_JDD_$CCC",  sheet("Table`1'")  firstrow(varlabels) sheetmodify	
		erase "transitions_$CCC.dta"
	restore
end

capture program drop jflows
program def jflows	
	sort id year
	cap g dL = L - L[_n-1]
	replace dL = L if age == 1
	cap g JCen = dL if age == 1
	cap g JCinc = dL if dL > 0 & age > 1 & age ~=. & exit ~= 2
	cap g JDex = dL if exit == 2
	cap g JDinc = dL if dL < 0 & age > 1 & exit ~= 2

	preserve
		collapse (sum) JC* JD* , by(year)
		sort year
		g creation=JCinc + JCen
		g destruction=JDinc + JDex  
		g net=creation+destruction
		g netinc=JCinc + JDinc
		for var creation destruction net* : replace X=X/1000
		for var JC* JD*: replace X=X/1000
		global startyr2 = $startyr + 1
		local lw="lwidth(medthick)"
		twoway (line JCinc year if year>=$startyr2 & year<=$endyr, sort lcolor(black) lpattern(solid) `lw') ///  
		(line JCen year if year>=$startyr & year<=$endyr, sort lcolor(black) lpattern(dash) `lw')   ///  
		(line JDinc year if year>=$startyr2 & year<=$endyr, sort lcolor(black) lpattern(tight_dot) `lw') ///  
		(line JDex year if year>=$startyr2 & year<=$endyr, sort lcolor(black) lpattern(longdash_3dot) `lw') ///  
		(line netinc year if year>=$startyr2 & year<=$endyr, sort  lcolor(black) lpattern(shortdash_dot_dot) `lw'),  ///  
		title(" ${country}: Job Flows", size(medium)) ytitle("total workers (000)")  ///  
		legend(lab(1 "JC by incumbents") lab(2 "JC by entry") /// 
		lab(3 "JD by incumbents") lab(4 "JD by exit") lab(5 "Net by incumbents") size(small)) /// 
		note("$datasource" "{it:Job Diagnostics (SPJ)}" , size(vsmall)) xlabel($startyr2(1)$endyr)
		qui graph save  "Fig`1'_jflows_$CCC.gph", replace
		qui graph export  "gr_png\Fig`1'_jflows_$CCC.png", as(png) replace
		cap la drop _all
		la var JCen "Job creation at entry (000)"
		la var JCinc "Job creation by incumbents (000)"
		la var JDex "Job destruction by exit (000)"
		la var JDinc "Job destruction by incumbents (000)"	
		la var creation "creation (000)"
		la var destruction "destruction (000)"
		la var net "net (000)"
		la var netinc "Net incumbents (000)"		
		export excel using "Output_data_JDD_$CCC" , sheet("Fig`1'") firstrow(varlabels) sheetmodify	
	restore
end	

capture program drop njc_profile
program def njc_profile	
	local lw="lwidth(medthick)"	
	local lc "lcolor(black)"
	local lpatt1="lpattern(solid)"
	local lpatt2="lpattern(longdash)"
	local lpatt3="lpattern(shortdash)"
	local lpatt4="lpattern(longdash_dot_dot)"
	local lpatt5="lpattern(tight_dot)"
	local lpatt6="lpattern(longdash_shortdash)"
	local lpatt7="lpattern(shortdash_dot_dot)"
	local lpatt8="lpattern(_--_#)"
	local lcb "lcolor(black)"
	local lcolor1 lcolor("0 35 69")
	local lcolor2 lcolor("0 173 228")
	local lcolor3 lcolor("0 96 104")
	local lcolor4 lcolor("0 100 80")
	local lcolor5 lcolor("27 117 184")
	local lcolor6 lcolor("109 110 112")
	local lcolor7 lcolor("0 35 69"*0.5)
	local lcolor8 lcolor("0 173 228"*0.5)
	if "$datatype" == "panel" {
	cap drop category_s
	preserve		
			decode `1', g(category_s)
			collapse (sum) JC* JD* , by(year `1' category_s)
			gen creation = JCinc + JCen
			gen destruction = JDinc + JDex
			g net=creation+destruction
			for var creation destruction net : replace X=X/1000
			for var JC* JD*: replace X=X/1000
			la var JCen "Job creation at entry (000)"
			la var JCinc "Job creation by incumbents (000)"
			la var JDex "Job destruction by exit (000)"
			la var JDinc "Job destruction by incumbents (000)"	
			la var creation "creation (000)"
			la var destruction "destruction (000)"
			la var net "net (000)"
					}

if "$datatype" == "cross" {
	cap drop category_s
	preserve		
			decode `1', g(category_s)
			collapse (sum) L , by(year `1' category_s)
			bys year `1': gen flow = L - L[_n-1]
			g creation = flow if flow >=0
			g destruction = flow if flow < 0
			g net=creation+destruction
			for var creation destruction net : replace X=X/1000
					}
			local lw="lwidth(medthick)"
			local leg ""
			local y = 1
			levelsof category_s, local (category_s)
			foreach j of local category_s {
				local leg "`leg' lab(`y' `j')"
				local y = `y' + 1
					}
			local gr ""
			sum `1'
			local mx = r(max)
			forval i = 1(1)`mx' {
				local gr "`gr' (line net year if year >= $startyr2 & year<=$endyr & `1'==`i',  sort `lcb' `lw'  `lpatt`i'' )"
						}
			twoway `gr', title("${country}: Net Job Creation")  /// 
			subtit(`3') ytitle("total workers (000)", size(small)) /// 
			xlabel($startyr2(1)$endyr, angle(vertical) labsize(small))  legend(`leg' size(small)) /// 
			note("$datasource" "{it:Job Diagnostics (SPJ)}" , size(vsmall))
			qui graph save "Fig`2'_nJC_`1'_$CCC.gph", replace
			qui graph export "gr_png\Fig`2'_nJC_`1'_$CCC.png", as(png) replace
			g variable = "`1'"
			replace variable = "All" if variable == ""
			ren `1' category
			sort variable category
			cap la drop _all
			order variable category category_s creation destruction net 
			la var JCen "Job creation at entry (000)"
			la var JCinc "Job creation by incumbents (000)"
			la var JDex "Job destruction by exit (000)"
			la var JDinc "Job destruction by incumbents (000)"	
			la var creation "creation (000)"
			la var destruction "destruction (000)"
			la var net "net (000)"
			export excel using "Output_data_JDD_$CCC" , sheet("Fig`2'") firstrow(varlabels) sheetmodify	
		restore
end

cap program drop tablea1
program def tablea1
	cap egen nyr = group(year)
	sum nyr
	local mx=r(max)
	local n = 2
	foreach var in $prodvar $avwage $Yvar $Y $rLC $K {
		if "`var" ~= "" {
			local n = `n' + 1
						}
					}
	tabstat L age $prodvar $avwage $Yvar $Y $rLC $K , statistics(count mean p50 sd min max) columns(statistics) save
	mat T = r(StatTotal)' 
	putexcel set "TableA1_$CCC.xlsx", replace
	putexcel A1 = "$country Summary Statistics"
	putexcel A2 = matrix(T), names
	local k = `n' + 3
	forval i=1(1)`mx' {
		sum year if nyr == `i'
		local yr`i' = r(max)
		putexcel A`k' = "yr`yr`i''"
		local k = `k' + 1
		tabstat L age $prodvar $avwage $Yvar $Y $rLC $K if year == `yr`i'', statistics(count mean p50 sd min max) columns(statistics) save
		mat T`k' = r(StatTotal)' 		
		putexcel A`k' = matrix(T`k'), names
		local k = `n' + `k' + 1
				}
end
capture program drop VAR_GEN
	program define VAR_GEN
	g countrycode="$CCC"
	g country="$country"
	g period="$period"
	g year ="$endyr"
	g formality="$formality"
	g employment="$employment"
	g sector="$sector"
	g threshold=$threshold
	g data="$data"
	g CCC="$CCC" + "-" + "$endyr"
	g datatype= "$datatype"
	sort countrycode period data CCC datatype
end

cap program drop benchmark 
program def benchmark
	cap egen s5 = group(sector5)
	sum s5
	local N = r(max)
	if `N' ~= 5 {
		global s5 = 0
				}
	if `N' == 5 {
		global s5 = 1
		preserve
			keep if year == $endyr
			collapse (sum) N L [$wgt=wgt] if sector5>1 & sector5~=., by(sector5)
				foreach v in N L {
					replace `v' = round(`v')
					egen `v'tot = sum(`v')
					forvalues x=2/5{
						g `v'`x' = 100*`v'/`v'tot if sector5 == `x'
								}
					cap ren `v'2 `v'MiningUtilities 
					cap ren `v'3 `v'Manufacturing 
					cap ren `v'4 `v'Construction 
					cap ren `v'5 `v'Services 
							}
							
			collapse (mean) N* L*
			cap la var NMiningUtilities "% firms in Mining, Quarrying, Utilities"
			cap la var LMiningUtilities "% employment in Manufacture"
			cap la var NManufacturing "% firms in Manufacture"
			cap la var LManufacturing "% employment in Manufacture"
			cap la var NConstruction "% firms in Construction"
			cap la var LConstruction "% employment in Construction"
			cap la var NServices "% firms in Services"
			cap la var LServices "% employment in Services"				
			VAR_GEN
			saveold "$input\JDD_benchmark_$CCC.dta", replace
	restore
			}
	sum sz_cls5
	local szmn = r(min)
	if `szmn' == 1 {
		preserve
			global micro = 1
			keep if year == $endyr
			collapse (sum) N L [$wgt=wgt] if sz_cls5~=., by(sz_cls5)
				foreach v in N L {
					replace `v' = round(`v')
					egen `v'tot = sum(`v')
					egen `v'lg = sum(`v') if sz_cls5 ==4 | sz_cls5 == 5
					g `v'micro = 100*`v'/`v'tot if sz_cls5 == 1
					g `v'large = 100*`v'lg/`v'tot if sz_cls5 ==5 
							}
					la var Nmicro "% micro firms (L<10)"
					la var Nlarge "% large firms (L 100+)"
					la var Lmicro "% employment in micro firms (L<10)" 
					la var Llarge "% employment in large firms (L 100+)"
					collapse (mean) *micro *large
					VAR_GEN
					if "$s5" == "1" {
						merge 1:1 countrycode period data CCC datatype using "$input\JDD_benchmark_$CCC.dta", nogen 
						sort countrycode period data CCC datatype 
								}
					saveold "$input\JDD_benchmark_$CCC.dta", replace	
		restore
					}
	if "$report_age" == "yes" {
		preserve
			keep if year == $endyr
			g young = (age <= 5) if age ~= .
			collapse (sum) N L [$wgt=wgt] if age ~=., by(young entry)
				foreach v in N L {
					replace `v' = round(`v')
					egen `v'tot = sum(`v')
					egen `v'young = sum(`v') if young == 1
					g `v'entry = 100*`v'/`v'tot if entry == 1
					replace `v'young = 100*`v'young/`v'tot if young == 1
					g `v'old = 100*`v'/`v'tot if young == 0
							}
			collapse (mean) Nentry Lentry Nyoung Lyoung Nold Lold
			la var Nentry  "entry rate"
			la var Lentry  "% L generated at entry"
			la var Lyoung "% employment by young firms"
			la var Nyoung  "% young firms (age 1-5)"
			la var Lyoung "% employment by young firms"
			la var Nold "% old firms (age >5)"
			la var Lold "% employment by old firms"
			VAR_GEN
			if "$s5" == "1" | "$micro" == "1" {
				merge 1:1 countrycode period data CCC datatype using "$input\JDD_benchmark_$CCC.dta", nogen
				sort countrycode period data CCC datatype 
					}
			saveold "$input\JDD_benchmark_$CCC.dta", replace	
		restore
				}

	preserve
		collapse (sum) L $Y if year == $Yvar_mxyr [$wgt = wgt], by (id)
		foreach v in L $Y {
			sum `v' , de
			local N = r(N)
			if `N' > 0 {
				g `v'1 = `v' if `v'>= r(p99) 
				egen `v'tot = sum(`v') 
				egen `v'1tot = sum(`v'1) 
				g `v'1pc = 100*`v'1tot/ `v'tot 
						}
							}
		ren ${Y}1pc S1pc
		collapse (mean) L1pc S1pc 
		la var L1pc "% employment by 1% largest firms"
		la var S1pc "% $Ytit by 1% largest firms"
		VAR_GEN
		if "$s5" == "1" | "$micro" == "1" | "$report_age" == "yes" {
			merge 1:1 countrycode period data CCC datatype using "$input\JDD_benchmark_$CCC.dta", nogen
			sort countrycode period data CCC datatype 
				}
		saveold "$input\JDD_benchmark_$CCC.dta", replace	
	restore		
	preserve
		if "$report_age" == "yes" {
			keep if year == $endyr
			g old = (age > 10) if age ~= .
			collapse (sum) N [$wgt=wgt] if sz_cls5 == 1, by(old)
			replace N = round(N)
			egen microtot = sum(N)
			g micro_old = N if old == 1
			replace micro_old = 100*micro_old/microtot
			collapse (mean) micro_old 
			g micro_young = 100 - micro_old
			la var micro_old " % micro firms older than 10"
			la var micro_young "% micro firms age 1-10"
			VAR_GEN
			merge 1:1 countrycode period data CCC datatype using "$input\JDD_benchmark_$CCC.dta", nogen
			saveold "$input\JDD_benchmark_$CCC.dta", replace	
					}
		use "$input\JDD_benchmark.dta", clear
		drop if country == "$country"
		append using "$input\JDD_benchmark_$CCC.dta"
		cap drop if f == 1
		cap drop f
		save "$input\JDD_benchmark.dta", replace

		local k = 1
		use "$input\JDD_benchmark.dta" , clear
		
		if $s5 == 1 {
			gr bar  NMiningUtilities  NManufacturing NConstruction NServices, over(country, label(angle(45) labsize(vsmall)) sort(Nmicro)) bar(1, color("0 35 69")) bar(2, color("0 173 228")) bar(3, color("0 96 104")) bar(4, color("27 117 184")) ///
			title ("Share of Firms", size(medsize)) subtitle("by Sector", size(medsmall))  legend(lab(1 "Mining Quarrying Utilities") lab(2 "Manufacturing") lab(3 "Construction") lab(4 "Services")  size(vsmall))  yla(, labsize(vsmall))  ytitle("%", size(vsmall)) ///
			stack percent note("{it:Job Diagnostics (SPJ)}", size(vsmall)) 
			qui graph save "$output\benchmark\Fig`k'_Bench_Nsect.gph", replace
			qui graph export "$output\benchmark\Fig`k'_Bench_Nsect.png", as(png) replace
			local k = `k' + 1
			gr bar  LMiningUtilities  LManufacturing LConstruction LServices, over(country, label(angle(45) labsize(vsmall)) sort(Nmicro)) bar(1, color("0 35 69")) bar(2, color("0 173 228")) bar(3, color("0 96 104")) bar(4, color("27 117 184")) ///
			title ("Share of Employment", size(medsize)) subtitle("by Sector", size(medsize))  legend(lab(1 "Mining Quarrying Utilities") lab(2 "Manufacturing") lab(3 "Construction") lab(4 "Services")  size(vsmall))  yla(, labsize(vsmall))  ytitle("%", size(vsmall)) ///
			stack percent note("{it:Job Diagnostics (SPJ)}", size(vsmall)) 
			qui graph save "$output\benchmark\Fig`k'_Bench_Lsect.gph", replace
			qui graph export "$output\benchmark\Fig`k'_Bench_Lsect.png", as(png) replace
			local k = `k' + 1
					}
		if $micro == 1 {
			gr bar  Nmicro Nlarge , over(country, label(angle(45) labsize(vsmall)) sort(Nmicro)) bar(1, color("0 35 69")) bar(2, color("0 173 228")) ///
			title("Share of Micro and Large Firms", size(medsize)) subtitle(" ", size(medsize))  legend(lab(1 "Micro (<10)") lab(2 "Large (100+)")  size(vsmall))  yla(, labsize(vsmall))  ytitle("%", size(vsmall)) ///
			note("Micro firms: size 1 to 9; large firms: size 100+" "{it:Job Diagnostics (SPJ)}", size(vsmall)) 
			qui graph save "$output\benchmark\Fig`k'_Bench_Nsz.gph", replace
			qui graph export "$output\benchmark\Fig`k'_Bench_Nsz.png", as(png) replace
			local k = `k' + 1
			gr bar  Lmicro Llarge, over(country, label(angle(45) labsize(vsmall)) sort(Lmicro)) bar(1, color("0 35 69")) bar(2, color("0 173 228")) ///
			title("Share of Employment: by Micro and Large Firms", size(medsize)) subtitle(" ", size(medsize))  legend(lab(1 "Micro (<10)") lab(2 "Large (100+)")  size(vsmall))  yla(, labsize(vsmall))  ytitle("%", size(vsmall)) ///
			note("Micro firms: size 1 to 9; large firms: size 100+" "{it:Job Diagnostics (SPJ)}" , size(vsmall)) 
			qui graph save "$output\benchmark\Fig`k'_Bench_Lsz.gph", replace
			qui graph export "$output\benchmark\Fig`k'_Bench_Lsz.png", as(png) replace
			local k = `k' + 1
					}
		if "$report_age" == "yes" {
			gr bar  Nyoung Nold, over(country, label(angle(45) labsize(vsmall)) sort(Nmicro)) bar(1, color("0 35 69")) bar(2, color("0 173 228")) ///
			title ("Share of Firms: by Young and Old Firms", size(medsize)) subtitle(" ", size(medsize))  legend(lab(1 "Young (<6)") lab(2 "Old (10+)")  size(vsmall))  yla(, labsize(vsmall))  ytitle("%", size(vsmall)) ///
			note("Young: age 1 to 5; old firms: age 10+" "{it:Job Diagnostics (SPJ)}", size(vsmall)) 
			qui graph save "$output\benchmark\Fig`k'_Bench_Nage.gph", replace
			qui graph export "$output\benchmark\Fig`k'_Bench_Nage.png", as(png) replace
			local k = `k' + 1
			gr bar  Nentry Lentry, over(country, label(angle(45) labsize(vsmall)) sort(Nentry)) bar(1, color("0 35 69")) bar(2, color("0 173 228")) ///
			title ("Entry Rate and % Employment Created at Entry", size(medsize)) subtitle(" ", size(medsize))  legend(lab(1 "% Entering Firms") lab(2 "% Employment at Entry")  size(vsmall))  yla(, labsize(vsmall))  ytitle("%", size(vsmall)) ///
			note("Denominator: total firms, total employment" "{it:Job Diagnostics (SPJ)}", size(vsmall)) 
			qui graph save "$output\benchmark\Fig`k'_Bench_entry.gph", replace
			qui graph export "$output\benchmark\Fig`k'_Bench_entry.png", as(png) replace
			local k = `k' + 1
			gr bar  Lyoung Lold, over(country, label(angle(45) labsize(vsmall)) sort(Nmicro)) bar(1, color("0 35 69")) bar(2, color("0 173 228")) ///
			title ("Share of Employment: by Young and Old Firms", size(medsize)) subtitle(" ", size(medsize))  legend(lab(1 "Young (<6)") lab(2 "Old (10+)")  size(vsmall))  yla(, labsize(vsmall))  ytitle("%", size(vsmall)) ///
			note("Young: age 1 to 5; old firms: age 10+" "{it:Job Diagnostics (SPJ)}", size(vsmall)) 
			qui graph save "$output\benchmark\Fig`k'_Bench_Lage.gph", replace
			qui graph export "$output\benchmark\Fig`k'_Bench_Lage.png", as(png) replace
			local k = `k' + 1
						}
		gr hbar L1pc if L1pc~=., over(country, label(labsize(small)) sort(L1pc) descending) title("Share of Employment", size(medsmall)) subtit("by Top 1% Largest Firms", size(medsmall))  ///
		bar(1, color("0 35 69")) ytit(Share,) yla(, labsize(vsmall)) note("{it:Job Diagnostics (SPJ)}" , size(vsmall))		
		qui graph save "$output\benchmark\Fig`k'_Bench_Lpc.gph",  replace 
		qui graph export "$output\benchmark\Fig`k'_Bench_Lpc.png", as(png) replace 
		local k = `k' + 1
		if "$Yvar" ~= "" {
			gr hbar S1pc if S1pc~=., over(country, label(labsize(small)) sort(S1pc) descending) title("Share of Revenues", size(medsmall)) subtit("by Top 1% Largest Firms", size(medsmall))  ///
			bar(1, color("0 173 228")) ytit(Share) yla(, labsize(vsmall)) note("{it:Job Diagnostics (SPJ)}" , size(vsmall))	
			qui graph save "$output\benchmark\Fig`k'_Bench_Spc.gph",  replace 	
			qui graph save "$output\benchmark\Fig`k'_Bench_Spc.gph",  replace 
			local k = `k' + 2
				}
		if $micro == 1 & "$report_age" == "yes" {
			for var micro_young micro_old: replace X = int(X)
			gr bar micro_young micro_old, over(country, label(angle(45) labsize(vsmall)) sort(micro_young)  descending) title("Micro Firms may not Grow or Exit", size(small))  ///
			bar(1, color(navy)) bar(2, color(cranberry)) stack  ytitle("Share", size(vsmall)) ylabel(,labsize(vsmall))  ///
			legend(lab(1 "% Micro Firms Age<10") lab(2 "% Micro Firms Age 10+") size(small)) blabel(bar, size(vsmall)) note("{it:Job Diagnostics (SPJ)}" , size(vsmall))	
			local nb=`.Graph.plotregion1.barlabels.arrnels'
			forval i=1/`nb' {
					di "`.Graph.plotregion1.barlabels[`i'].text[1]'%"
					.Graph.plotregion1.barlabels[`i'].text[1]="  `.Graph.plotregion1.barlabels[`i'].text[1]'%"
								}
			.Graph.drawgraph
			qui graph save "$output\benchmark\Fig`k'_Bench_microage.gph",  replace
			qui graph export "$output\benchmark\Fig`k'_Bench_microage.png", as(png) replace
					}
		erase "$input\JDD_benchmark_$CCC.dta"
		local k = `k' - 1
	restore
	if "$report_age" == "yes" {
		local ag = 2
		foreach g in agehk_5to9 agehk_10to14 agehk_15to19 agehk_20to24 agehk_25to29 agehk_30to34 agehk_35to39 agehk_40plus {
			cap g `g' = (agehk_cls9 == `ag') if agehk_cls9!=.
			local ag = `ag' +1
								}

		local agehkd ""
		foreach i in agehk_5to9 agehk_10to14 agehk_15to19 agehk_20to24 agehk_25to29 agehk_30to34 agehk_35to39 agehk_40plus {
			count if `i'!=0 & agehk_cls9!=.
			if r(N)>20 {
					local agehkd "`agehkd' `i'" 
						}
					}
		global agehkd "`agehkd'"	
		foreach var in lnL ln$Y {
			preserve
				xi: reg `var' $agehkd , r
				regsave $agehkd , pval ci level(95)
				VAR_GEN
				drop if var == "" 
				g age=.
				replace age=2 if var=="agehk_5to9"
				replace age=3 if var=="agehk_10to14"
				replace age=4 if var=="agehk_15to19"
				replace age=5 if var=="agehk_20to24"
				replace age=6 if var=="agehk_25to29"
				replace age=7 if var=="agehk_30to34"
				replace age=8 if var=="agehk_35to39"
				replace age=9 if var=="agehk_40plus"
				sum coef 
				local N = r(N) + 1
				set obs `N'
				replace age=1 if age==.
				replace coef=1 if coef==.
				replace var="agehk_<5" if var == ""
				replace countrycode="$CCC" if countrycode==""
				g coef1=coef+1 if pval<=0.05
				replace coef1=1 if coef1==.
				replace country="$country" if countrycode=="$CCC" & country==""
				lab define age 1 "<5" 2 "5-9" 3 "10-14" 4 "15-19" 5 "20-24" 6 "25-29" 7 "30-34" 8 "35-39" 9 "40+"
				lab val age age
				g Yvar="`var'"
				append using "$input\JDD_lifecycle_$CCC.dta"
				saveold "$input\JDD_lifecycle_$CCC.dta", replace
				use "$input\JDD_lifecycle.dta", clear
				drop if country == "$country"
				append using "$input\JDD_lifecycle_$CCC.dta"
				save "$input\JDD_lifecycle.dta", replace
				if "`var'"  == "lnL" {		
					twoway (line coef age if country=="$country" & Yvar == "lnL", lpattern(solid) lcolor(red) sort) ///
					(line coef age if strpos(country, "$country1") & Yvar == "lnL", lpattern(longdash) lcolor(blue) sort) ///
					(line coef age if strpos(country, "$country2") & Yvar == "lnL", lpattern(shortdash) lcolor(green) sort) ///
					(line coef age if strpos(country, "$country3") & Yvar == "lnL", lpattern(tightdot) lcolor(purple) sort), ///
					tit("Average N. Workers)", size(medium)) subtit("By Age", size(small)) ///
					ytit("Average size (age<5 =1)", size(small)) xsc(r(1 9)) ysc(r(1 9))  ylabel(1(1)9, labsize(vsmall)) xlabel(1(1)9, valuelabel labsize(vsmall)) /// 
					xtit("Age", size(small)) legend(lab(1 $country) lab(2 $country1) lab(3 $country2) lab(4 $country3) size(vsmall)) ///
					note("{it:WB-Job Diagnostics}",  size(vsmall)) 
					qui graph save "$output\benchmark\Fig`k'_Bench_lifecyc.gph", replace
					qui graph export "$output\benchmark\Fig`k'_Bench_lifecyc.png", as(png) replace
										}
		restore			
					}
							}
		erase "$input\JDD_lifecycle_$CCC.dta"
end
cap program drop grgen
program def grgen
if "$eps" == "yes" { 
		clear
		cap mkdir "${output}\\gr_eps"
		local datfiles : dir "." files "*.gph"
		foreach f of local datfiles {
			cd "$output"
			cap graph close
			gr use "`f'"
			local f2 = subinstr("`f'",".gph","",1)
			di "f = `f' and f2 = `f2'"
			cd "${output}\\gr_eps"
			graph export "`f2'.eps", as(eps) replace
					}
							}							
end 
