set more off
cap log close

clear
qui do "$dofiles/regsave.do"
cap mkdir "${output}\\gr_png"
set scheme s2color
cd "$output"

log using "WBSPJ_JDD_enquiry.log", replace

cap mkdir "$output\benchmark"
set obs 1
g f = 1
save "T1_sumstats_${endyr}_$CCC.dta", replace
save "$input\JDD_lifecycle_$CCC.dta", replace
g decile = 99
drop f
save "$input\JDD_ypc10_$CCC.dta", replace
use "$input\PROD2_label.dta", clear
sort PROD2
save, replace
clear

use "$dataset", clear
	if "$Yvar" ~= "" {
		sum year if $Yvar ~= .
		global Yvar_mnyr = r(min)
		global Yvar_mxyr = r(max)
				}
	else {
		global Yvar_mnyr = $startyr
		global Yvar_mxyr = $endyr
				}
*Question 1: What is the qui profile of the formal sector and how it evolved overtime? 
local k = 1
qui profile N sector10 "Firms" "by Sector" "Firms" `k' 4
local k =  `k' + 1
qui profile L sector10 "Workers" "by Sector" "Workers" `k' 4
local k =  `k' + 1
if "$Yvar" ~= "" {
	qui profile $Yvar sector10 "$Yvartit" "by Sector" "${unit}" `k' 4
		}
local k =  `k' + 1
if $region == 1 {
	qui profile N region "Firms" "by Region" "Firms" `k' 4
	local k =  `k' + 1
	qui profile L region "Workers" "by Region" "Workers" `k' 4
	local k =  `k' + 1
	if "$Yvar" ~= "" {
		qui profile $Yvar region "$Yvartit" "by Region" "${unit}" `k' 4
		local k =  `k' + 1
				}	
			}
qui profile N sz_cls5 "Firms" "by Size" "Firms" `k' 2
local k =  `k' + 1
qui profile L sz_cls5 "Workers" "by Size" "Workers" `k' 2
local k =  `k' + 1
if "$Yvar" ~= "" {
	qui profile $Yvar sz_cls5 "$Yvartit" "by Size" "${unit}" `k' 2
local k =  `k' + 1
		}
if "$report_age" == "yes" {
	qui profile N age_cls4 "Firms" "by Age" "Firms" `k'  2
	local k =  `k' + 1
	qui profile L age_cls4 "Workers" "by Age" "Workers" `k' 2
	local k =  `k' + 1
	if "$Yvar" ~= "" {
		qui profile $Yvar age_cls4 "$Yvartit" "by Age" "${unit}" `k' 2
		local k =  `k' + 1
					}
				}	
if $ownership == 1 {
	qui profile N ownership "Firms" "by Ownership" "Firms" `k' 2
	local k =  `k' + 1
	qui profile L ownership "Workers" "by Ownership" "Workers" `k' 2
	local k =  `k' + 1
	if "$Yvar" ~= "" {
		qui profile $Yvar ownership "$Yvartit" "by Ownership" "${unit}" `k' 2 
		local k =  `k' + 1
				}
				}	
if "$prodvar" ~= "" {
	qui profile L ${prodvar}_quartile "Workers" "by Productivity" "Workers" `k' 2
	local k =  `k' + 1
				}
preserve
	use "T1_sumstats_${endyr}_$CCC.dta", clear
	drop if f == 1
	drop f
	sort var dimension categoryn 
	export excel using "Tables_JDD_$CCC" , sheet("Table1") firstrow(varlabels) sheetmodify	
	erase "T1_sumstats_${endyr}_$CCC.dta"
restore
mktsh	

*Question 2: What are the aggregate sectoral conditions and changes in the formal private sector? 

table3 

if $byyear > 1 & "$Y" ~= "" {
	qui bubbles `k'	
	local k =  `k' + 1
			}
if $byyear > 1 {	
	qui prod2 `k'
	local k =  `k' + 1
		}
if $byyear > 1 & "$Y" ~= "" {
	qui decompositions_sector $Yvar "$prodvartit" L `k'
	local k =  `k' + 1
			}
if $byyear > 1 & $capital == 1 {
	qui trends `k'
	local k =  `k' + 1
		}
				
*Question 3: What is the pattern and trend in firm level growth dynamics and jobs outcomes by firm type?  

if $byyear > 1 & "$prodvar" ~= "" {		
	qui ypc10 `k'
	local k = `k' + 1
	qui densityyr `k'
	local k =  `k' + 1
			}

if $byyear > 1 & "$prodvar" ~= "" {		
	qui deltayr `k'
	local k =  `k' + 1
				}
				
if "$prodvar" ~= "" {			
	qui densityX ln$prodvar sz_cls3 small medium large "${prodvartit}" `k'
	local k =  `k' + 1
	if "$report_age" == "yes" {
		qui densityX ln$prodvar age_cls3 young mature old "${prodvartit}" `k'
		local k =  `k' + 1
				}
	if $ownership == 1 {
		qui densityX ln$prodvar ownership domestic foreign "state owned" "${prodvartit}" `k'
		local k =  `k' + 1
					}	
				}
			
if "$prodvar" ~= "" & $wages ~= 0 {				
	qui meanLPwage `k'
	local k =  `k' + 1
		}
if "$report_age" == "yes" {	
	qui entry `k' sector5 Sector
	local k =  `k' + 1
	if $region == 1 {
		qui entry `k' region Region
		local k =  `k' + 1
			}
		}
regvars
qui multivariate lnL  Size young, domestic, food&beverages, $reg1,  "and low-productivity" "" `k'
local k =  `k' + 1
sum sz_cls5
if r(min) == 1 {
	local szref  "micro"
	}
if r(min) == 2 {
	local szref  "vsmall"
	}
if r(min) == 3 {
	local szref  "small"
	}
if "$prodvar" ~= "" {
	qui multivariate $prodvar "Labor Productivity" `szref', young, domestic, food&beverages, "and $reg1" "" `k'
	local k =  `k' + 1
				}
if $wages ~= 0 {
	qui multivariate rwage  Wage `szref', young, domestic, food&beverages, $reg1,  "and low-productivity" `k'
	local k =  `k' + 1
				}
	if "$prodvar" ~= "" {
		qui OP $prodvar PROD2 a
		qui OP $prodvar sector10 b 
		qui OP $prodvar sector5 c
			if $byyear > 1  {
			qui OPgraph sector10 `k'
			local k =  `k' + 1			
						}
				}
if "$datatype"== "panel" {
	qui xpand	
	qui transitions 5
	qui jflows  `k'
	local k =  `k' + 1

	qui njc_profile sector5 `k' "by Sector" 
	local k =  `k' + 1

	if $region == 1 {
		qui njc_profile region `k' "by Location"
		local k =  `k' + 1
			}
	qui njc_profile sz_cls3 `k' "by Size"
	local k =  `k' + 1
	if "$report_age" == "yes" {
		qui njc_profile age_cls4 `k' "by Age"	
		local k =  `k' + 1
				}
	if $ownership == 1 {
		qui njc_profile ownership `k' "by Ownership"			
		local k =  `k' + 1
					}

		qui multivariate exit Exit `szref', young, domestic, food&beverages, $reg1,  "and low-productivity" `k'
		local k =  `k' + 1
		qui multivariate Lg  "Labor Growth" `szref', young, domestic, food&beverages, $reg1,  "and low-productivity" `k'
		local k =  `k' + 1
		if $valueadded == 1 {
		qui multivariate LPVg "Labor Productivity" `szref', young, domestic, food&beverages, "and $reg1" "" `k'
		local k =  `k' + 1
							 }
		global panelX "$exit $Lg $Pgreg"
		if $wages ~= 0  {
		qui multivariate Wg  Wage `szref', young, domestic, food&beverages, $reg1,  "and low-productivity" `k'
				}
		local k =  `k' + 1
		global panelX "$exit $Lg $Pgreg $Wg"
		drop if exit == 2
				 }                     
	  
if $benchmark == 1 { 
	qui benchmark
		}
		
tablea1
if "$datatype"== "cross" {            
		cd "${output}"
        global panelX ""
                            }

foreach x in $lnL $Preg $rwage $panelX {
	preserve
		  use "`x'_dta.dta", clear
		  export excel using "Regressions_JDD_$CCC" , sheet("`x'") sheetmodify   
		  erase "`x'_dta.dta"
		  erase "`x'.txt"
	restore
                  }
grgen

cap log close
